/**
 * @Company: 云南奇讯科技有限公司
 * @Author: yxf
 * @Description: 商城微信支付
 * @Date: 2024/05/12 10:50
 */

package wechat

import (
	"github.com/ArtisanCloud/PowerWeChat/v3/src/kernel/models"
	"github.com/gogf/gf/v2/frame/g"
)

// WechatPayNotifyReq 微信支付通知请求参数
type WechatPayNotifyReq struct {
	g.Meta `path:"/notify" method:"POST" tags:"微信接口/微信支付/支付通知"`
}

// WechatPayNotifyRes 微信支付通知响应参数
type WechatPayNotifyRes struct {
	Code    string `json:"code"`
	Message string `json:"message"`
}

type WechatPayQuerOrderReq struct {
	g.Meta     `path:"/queryOrder" method:"get" tags:"微信接口/微信支付/支付订单查询"`
	OutTradeNo string `p:"outTradeNo"  v:"required#商户订单号必须"` // 商户订单
}

type WechatPayQuerOrderRes struct {
	g.Meta         `mime:"application/json"`
	AmountTotal    int                      `json:"amountTotal"`
	Openid         *models.TransactionPayer `json:"openid"`
	successTime    string                   `json:"successTime"`
	TradeState     string                   `json:"tradeState"`
	TradeType      string                   `json:"tradeType"`
	TransactionId  string                   `json:"transactionId"`
	TradeStateDesc string                   `json:"tradeStateDesc"`
	SuccessTime    string                   `json:"successTime"`
}
