/**
 * @Company: 云南奇讯科技有限公司
 * @Author: yxf
 * @Description: 商城订单常量
 * @Date: 2024/2/29 16:48
 */

package storeOrder

const (
	STORE_ORDER_STATUS_CANCELED    = iota - 1 // 取消订单
	STORE_ORDER_STATUS_UNPAID                 // 待支付
	STORE_ORDER_STATUS_WAITDELIVER            // 待发货
	STORE_ORDER_STATUS_DELIVERED              // 待收货
	STORE_ORDER_STATUS_COMPLETED              // 已收货 待评价
	STORE_ORDER_STATUS_CLOSED                 // 已关闭
)

const (
	STORE_ORDER_PAY_STATUS_FAILURE = iota - 1 // 支付失败
	STORE_ORDER_PAY_STATUS_UNPAID             // 未支付
	STORE_ORDER_PAY_STATUS_SUCCESS            // 支付成功
)

const (
	STORE_PAYTYPE_WECHAT_PAY         = "wechat_pay"         // 微信支付
	STORE_PAYTYPE_WECHAT_NATIVE      = "wechat_pay_native"  // 微信扫码支付
	STORE_PAYTYPE_ALIPAY             = "alipay"             // 支付宝支付
	STORE_PAYTYPE_BALANCE_PAY        = "balance_pay"        // 余额支付
	STORE_PAYTYPE_OFFLINE_PAY        = "offline_pay"        // 线下支付
	STORE_PAYTYPE_WECHAT_FRIEND_PAY  = "wechat_friend_pay"  // 微信好友支付
	STORE_PAYTYPE_MANUAL_CONFIRM_PAY = "manual_confirm_pay" // 后台确认支付
)

const (
	STORE_ORDER_SEARCH_KEYWORDS_TYPE_ORDER_NO = iota
	STORE_ORDER_SEARCH_KEYWORDS_TYPE_REALNAME
	STORE_ORDER_SEARCH_KEYWORDS_TYPE_MOBILE
	STORE_ORDER_SEARCH_KEYWORDS_TYPE_GOODS_NAME
)
