// ==========================================================================
// GFast自动生成logic操作代码。
// 生成日期：2024-01-05 17:55:38
// 生成路径: internal/app/store/finance/logic/store_finance_recharge_log.go
// 生成人：gfast
// desc:充值记录
// company:云南奇讯科技有限公司
// ==========================================================================

package logic

import (
	"context"
	"errors"
	"github.com/gogf/gf/v2/database/gdb"
	"github.com/gogf/gf/v2/frame/g"
	"github.com/gogf/gf/v2/os/gtime"
	"github.com/gogf/gf/v2/util/gconv"
	commonService "github.com/tiger1103/gfast/v3/internal/app/common/service"
	storeConsts "github.com/tiger1103/gfast/v3/internal/app/store/consts/finance"
	storeOrderConsts "github.com/tiger1103/gfast/v3/internal/app/store/consts/storeOrder"
	"github.com/tiger1103/gfast/v3/internal/app/store/finance/dao"
	"github.com/tiger1103/gfast/v3/internal/app/store/finance/model"
	"github.com/tiger1103/gfast/v3/internal/app/store/finance/model/do"
	"github.com/tiger1103/gfast/v3/internal/app/store/finance/service"
	memberModel "github.com/tiger1103/gfast/v3/internal/app/store/member/model"
	serviceMember "github.com/tiger1103/gfast/v3/internal/app/store/member/service"
	orderService "github.com/tiger1103/gfast/v3/internal/app/store/order/service"
	storeCommonModel "github.com/tiger1103/gfast/v3/internal/app/store/storeCommon/model"
	"github.com/tiger1103/gfast/v3/internal/app/system/consts"
	"github.com/tiger1103/gfast/v3/library/liberr"
	"math/rand"
	"time"
)

func init() {
	service.RegisterStoreFinanceRechargeLog(New())

}

func New() service.IStoreFinanceRechargeLog {
	return &sStoreFinanceRechargeLog{}
}

type sStoreFinanceRechargeLog struct{}

func (s *sStoreFinanceRechargeLog) List(ctx context.Context, req *model.StoreFinanceRechargeLogSearchReq) (listRes *model.StoreFinanceRechargeLogSearchRes, err error) {
	listRes = new(model.StoreFinanceRechargeLogSearchRes)
	err = g.Try(ctx, func(ctx context.Context) {
		m := dao.StoreFinanceRechargeLog.Ctx(ctx).WithAll()
		if req.RechargeNo != "" {
			m = m.Where(dao.StoreFinanceRechargeLog.Columns().RechargeNo+" = ?", req.RechargeNo)
		}
		if req.PayType != "" {
			m = m.Where(dao.StoreFinanceRechargeLog.Columns().PayType+" = ?", req.PayType)
		}
		if req.PayNo != "" {
			m = m.Where(dao.StoreFinanceRechargeLog.Columns().PayNo+" = ?", req.PayNo)
		}
		if req.Paid != "" {
			m = m.Where(dao.StoreFinanceRechargeLog.Columns().Paid+" = ?", gconv.Int(req.Paid))
		}
		if len(req.DateRange) > 0 {
			m = m.Where("created_at >= ? AND created_at<=?", req.DateRange[0], req.DateRange[1])
		}
		listRes.Total, err = m.Count()
		liberr.ErrIsNil(ctx, err, "获取总行数失败")
		if req.PageNum == 0 {
			req.PageNum = 1
		}
		listRes.CurrentPage = req.PageNum
		if req.PageSize == 0 {
			req.PageSize = consts.PageSize
		}
		order := "id asc"
		if req.OrderBy != "" {
			order = req.OrderBy
		}
		var res []*model.StoreFinanceRechargeLogListRes
		err = m.Page(req.PageNum, req.PageSize).Order(order).Scan(&res)
		liberr.ErrIsNil(ctx, err, "获取数据失败")
		listRes.List = make([]*model.StoreFinanceRechargeLogListRes, len(res))
		for k, v := range res {
			listRes.List[k] = &model.StoreFinanceRechargeLogListRes{
				Id:             v.Id,
				Uid:            v.Uid,
				RechargeNo:     v.RechargeNo,
				RechargeAmount: v.RechargeAmount,
				GiftAmount:     v.GiftAmount,
				PayType:        v.PayType,
				PayNo:          v.PayNo,
				Paid:           v.Paid,
				PayTime:        v.PayTime,
				CreatedAt:      v.CreatedAt,
				Remark:         v.Remark,
				Status:         v.Status,
				Member:         v.Member,
			}
		}
	})
	return
}

func (s *sStoreFinanceRechargeLog) GetById(ctx context.Context, id uint64) (res *model.StoreFinanceRechargeLogInfoRes, err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		err = dao.StoreFinanceRechargeLog.Ctx(ctx).WithAll().Where(dao.StoreFinanceRechargeLog.Columns().Id, id).Scan(&res)
		liberr.ErrIsNil(ctx, err, "获取信息失败")
	})
	return
}

func (s *sStoreFinanceRechargeLog) GetByRechargeNo(ctx context.Context, rechargeNo string) (res *model.StoreFinanceRechargeLogInfoRes, err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		err = dao.StoreFinanceRechargeLog.Ctx(ctx).WithAll().Where(dao.StoreFinanceRechargeLog.Columns().RechargeNo, rechargeNo).Scan(&res)
		liberr.ErrIsNil(ctx, err, "获取信息失败")
	})
	return
}
func (s *sStoreFinanceRechargeLog) GetByPayNo(ctx context.Context, payOrder string) (res *model.StoreFinanceRechargeLogInfoRes, err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		err = dao.StoreFinanceRechargeLog.Ctx(ctx).WithAll().Where(dao.StoreFinanceRechargeLog.Columns().PayNo, payOrder).Scan(&res)
		liberr.ErrIsNil(ctx, err, "获取信息失败")
	})
	return
}

func (s *sStoreFinanceRechargeLog) Add(ctx context.Context, req *model.StoreFinanceRechargeLogAddReq) (err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		_, err = dao.StoreFinanceRechargeLog.Ctx(ctx).Insert(do.StoreFinanceRechargeLog{
			Uid:            req.Uid,
			RechargeNo:     req.RechargeNo,
			RechargeAmount: req.RechargeAmount,
			GiftAmount:     req.GiftAmount,
			PayType:        req.PayType,
			PayNo:          req.PayNo,
			Paid:           req.Paid,
			PayTime:        req.PayTime,
			Remark:         req.Remark,
			Status:         req.Status,
		})
		liberr.ErrIsNil(ctx, err, "添加失败")
	})
	return
}

func (s *sStoreFinanceRechargeLog) Edit(ctx context.Context, req *model.StoreFinanceRechargeLogEditReq) (err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		_, err = dao.StoreFinanceRechargeLog.Ctx(ctx).WherePri(req.Id).Update(do.StoreFinanceRechargeLog{
			Uid:            req.Uid,
			RechargeNo:     req.RechargeNo,
			RechargeAmount: req.RechargeAmount,
			GiftAmount:     req.GiftAmount,
			PayType:        req.PayType,
			PayNo:          req.PayNo,
			Paid:           req.Paid,
			PayTime:        req.PayTime,
			Remark:         req.Remark,
			Status:         req.Status,
		})
		liberr.ErrIsNil(ctx, err, "修改失败")
	})
	return
}

func (s *sStoreFinanceRechargeLog) Delete(ctx context.Context, ids []uint64) (err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		_, err = dao.StoreFinanceRechargeLog.Ctx(ctx).Delete(dao.StoreFinanceRechargeLog.Columns().Id+" in (?)", ids)
		liberr.ErrIsNil(ctx, err, "删除失败")
	})
	return
}

// Pay 支付余额充值订单
func (s *sStoreFinanceRechargeLog) Pay(ctx context.Context, req *model.StoreFinanceRechargePayArgs) (res interface{}, err error) {
	var balanceRechargeInfo *model.StoreFinanceRechargeLogInfoRes
	err = g.Try(ctx, func(ctx context.Context) {
		err = dao.StoreFinanceRechargeLog.Ctx(ctx).WithAll().Where(g.Map{
			"uid":         req.Uid,
			"recharge_no": req.RechargeNo,
			"paid":        storeConsts.BALANCE_RECHARGE_PAY_NO,
		}).Scan(&balanceRechargeInfo)
		if err != nil || balanceRechargeInfo == nil {
			liberr.ErrIsNil(ctx, errors.New("订单信息无效"))
		}

		balanceRechargeInfo.PayType = req.PayType
		// 生成交易订单号，防止第三方平台支付时out_trade_no重复问题
		number, _ := commonService.SnowID().GenID() //交易订单号
		balanceRechargeInfo.PayNo = gconv.String(number)
		_, err = dao.StoreFinanceRechargeLog.Ctx(ctx).Where(dao.StoreFinanceRechargeLog.Columns().RechargeNo, req.RechargeNo).Update(do.StoreFinanceRechargeLog{
			PayNo: balanceRechargeInfo.PayNo,
		})
		liberr.ErrIsNil(ctx, err, "生成交易订单号失败")
		switch req.PayType {
		case storeOrderConsts.STORE_PAYTYPE_WECHAT_PAY:
			res, err = orderService.StorePayment().WeChatRecharge(ctx, req.Openid, req.WechatPayType, balanceRechargeInfo)
			//case storeConsts.STORE_PAYTYPE_ALIPAY:
			//	//err = service.StorePayment().Alipay(ctx, orderInfo)
			//case storeConsts.STORE_PAYTYPE_BALANCE_PAY:
			//	//err = service.StorePayment().BalancePay(ctx, orderInfo)
			//case storeConsts.STORE_PAYTYPE_OFFLINE_PAY:
			//	//err = service.StorePayment().OfflinePay(ctx, orderInfo)
			//case storeConsts.STORE_PAYTYPE_WECHAT_FRIEND_PAY:
			//	//res, err = service.StorePayment().WechatFriendPay(ctx, payArgs.Openid, orderInfo)
			//case storeConsts.STORE_PAYTYPE_WECHAT_NATIVE:
			//	//res, err = service.StorePayment().WechatNativePay(ctx, payArgs.Openid, orderInfo)
		}
		liberr.ErrIsNil(ctx, err)
	})

	return
}

// 处理余额充值支付结果回调
func (s *sStoreFinanceRechargeLog) HandlePayStatus(ctx context.Context, data *storeCommonModel.StorePaymentEventData) (err error) {
	return g.DB().Transaction(ctx, func(ctx context.Context, tx gdb.TX) error {
		return g.Try(ctx, func(ctx context.Context) {

			rechargeInfo, err := s.GetByPayNo(ctx, data.OutTradeNo)
			liberr.ErrIsNil(ctx, err)
			if rechargeInfo == nil {
				liberr.ErrIsNil(ctx, errors.New("订单不存在"))
			}
			memberInfo, err := serviceMember.StoreMember().GetByUid(ctx, rechargeInfo.Uid)

			//更新余额充值订单状态为已支付
			rechargeDo := &do.StoreFinanceRechargeLog{
				Paid:    data.Paid,
				PayTime: gtime.Now(),
				PayType: data.PayType,
				PayNo:   data.OutTradeNo,
			}
			_, err = dao.StoreFinanceRechargeLog.Ctx(ctx).Where(dao.StoreFinanceRechargeLog.Columns().RechargeNo, rechargeInfo.RechargeNo).Update(rechargeDo)
			liberr.ErrIsNil(ctx, err, "充值订单状态更新失败")

			//增加用户余额
			err = serviceMember.StoreMember().UpdateBalance(ctx, rechargeInfo.Uid, rechargeInfo.RechargeAmount+rechargeInfo.GiftAmount)
			liberr.ErrIsNil(ctx, err, "充值余额失败")
			memberInfo.Balance += gconv.Float64(rechargeInfo.RechargeAmount)
			//记录余额充值记录
			err = serviceMember.StoreMemberBalanceLog().Add(ctx, &memberModel.StoreMemberBalanceLogAddReq{
				MemberId:    gconv.Int64(rechargeInfo.Uid),
				Number:      rechargeInfo.RechargeAmount + rechargeInfo.GiftAmount,
				Balance:     memberInfo.Balance,
				DataSrc:     "用户充值",
				Description: "用户充值" + gconv.String(rechargeInfo.RechargeAmount) + "元,充值奖励" + gconv.String(rechargeInfo.GiftAmount) + "元。",
				IsType:      0,
			})
			liberr.ErrIsNil(ctx, err, "余额充值记录失败")
			// 使用时间戳作为流水号的一部分
			timestamp := time.Now().UnixNano() / 1e6
			// 生成随机数作为流水号的另一部分
			random := rand.Intn(999999) // 可以根据需要生成不同位数的随机数
			//增加财务流水记录
			err = service.StoreFinanceFlow().Add(ctx, &model.StoreFinanceFlowAddReq{
				Uid:      rechargeInfo.Uid,
				FlowNo:   gconv.String(timestamp) + gconv.String(random),
				FlowType: gconv.String(storeConsts.FINANCE_TYPE_RECHARGE),
				Amount:   rechargeInfo.RechargeAmount,
				OrderId:  data.OutTradeNo,
				PayType:  data.PayType,
				Remark:   "用户充值余额",
			})
			liberr.ErrIsNil(ctx, err, "财务流水记录失败")

		})
	})
}
