// ==========================================================================
// GFast自动生成model操作代码。
// 生成日期：2024-01-05 17:55:38
// 生成路径: internal/app/store/finance/model/store_finance_recharge_log.go
// 生成人：gfast
// desc:充值记录
// company:云南奇讯科技有限公司
// ==========================================================================

package model

import (
	"github.com/gogf/gf/v2/os/gtime"
	"github.com/gogf/gf/v2/util/gmeta"
	comModel "github.com/tiger1103/gfast/v3/internal/app/common/model"
)

// StoreFinanceRechargeLogInfoRes is the golang structure for table store_finance_recharge_log.
type StoreFinanceRechargeLogInfoRes struct {
	gmeta.Meta     `orm:"table:store_finance_recharge_log"`
	Id             uint64        `orm:"id,primary" json:"id,string" dc:"ID"`             // ID
	Uid            uint64        `orm:"uid" json:"uid" dc:"ucenterID"`                   // ucenterID
	RechargeNo     string        `orm:"recharge_no" json:"rechargeNo" dc:"充值单号"`         // 充值单号
	RechargeAmount float64       `orm:"recharge_amount" json:"rechargeAmount" dc:"充值金额"` // 充值金额
	GiftAmount     float64       `orm:"gift_amount" json:"giftAmount" dc:"赠送金额"`         // 赠送金额
	PayType        string        `orm:"pay_type" json:"payType" dc:"支付方式"`               // 支付方式
	PayNo          string        `orm:"pay_no" json:"payNo" dc:"支付单号"`                   // 支付单号
	Paid           int           `orm:"paid" json:"paid" dc:"是否支付"`                      // 是否支付
	PayTime        *gtime.Time   `orm:"pay_time" json:"payTime" dc:"支付日期"`               // 支付日期
	CreatedAt      *gtime.Time   `orm:"created_at" json:"createdAt" dc:"创建日期"`           // 创建日期
	UpdatedAt      *gtime.Time   `orm:"updated_at" json:"updatedAt" dc:"更新日期"`           // 更新日期
	DeletedAt      *gtime.Time   `orm:"deleted_at" json:"deletedAt" dc:"删除日期"`           // 删除日期
	Remark         string        `orm:"remark" json:"remark" dc:"备注"`                    // 备注
	Status         int           `orm:"status" json:"status" dc:"状态"`                    // 状态
	LinkedMember   *LinkedMember `orm:"with:id=uid" json:"linkedMember" dc:"会员"`
}

type StoreFinanceRechargeLogListRes struct {
	gmeta.Meta     `orm:"table:store_finance_recharge_log"`
	Id             uint64        `json:"id" dc:"ID"`
	Uid            uint64        `json:"uid" dc:"ucenterID"`
	RechargeNo     string        `json:"rechargeNo" dc:"充值单号"`
	RechargeAmount float64       `json:"rechargeAmount" dc:"充值金额"`
	GiftAmount     float64       `json:"giftAmount" dc:"赠送金额"`
	PayType        string        `json:"payType" dc:"支付方式"`
	PayNo          string        `json:"payNo" dc:"支付单号"`
	Paid           int           `json:"paid" dc:"是否支付"`
	PayTime        *gtime.Time   `json:"payTime" dc:"支付日期"`
	CreatedAt      *gtime.Time   `json:"createdAt" dc:"创建日期"`
	Remark         string        `json:"remark" dc:"备注"`
	Status         int           `json:"status" dc:"状态"`
	Member         *LinkedMember `orm:"with:id=uid" json:"member" dc:"会员"`
}

// StoreFinanceRechargeLogSearchReq 分页请求参数
type StoreFinanceRechargeLogSearchReq struct {
	comModel.PageReq
	RechargeNo string `p:"rechargeNo" dc:"充值单号"` //充值单号
	PayType    string `p:"payType" dc:"支付方式"`    //支付方式
	PayNo      string `p:"payNo" dc:"支付单号"`      //支付单号
	Paid       string `p:"paid" dc:"是否支付"`       //是否支付
}

// StoreFinanceRechargeLogSearchRes 列表返回结果
type StoreFinanceRechargeLogSearchRes struct {
	comModel.ListRes
	List []*StoreFinanceRechargeLogListRes `json:"list"`
}

// StoreFinanceRechargeLogAddReq 添加操作请求参数
type StoreFinanceRechargeLogAddReq struct {
	Uid            uint64      `p:"uid"  dc:"ucenterID"`
	RechargeNo     string      `p:"rechargeNo"  dc:"充值单号"`
	RechargeAmount float64     `p:"rechargeAmount"  dc:"充值金额"`
	GiftAmount     float64     `p:"giftAmount"  dc:"赠送金额"`
	PayType        string      `p:"payType"  dc:"支付方式"`
	PayNo          string      `p:"payNo"  dc:"支付单号"`
	Paid           int         `p:"paid"  dc:"是否支付"`
	PayTime        *gtime.Time `p:"payTime"  dc:"支付日期"`
	Remark         string      `p:"remark"  dc:"备注"`
	Status         int         `p:"status"  dc:"状态"`
}

// StoreFinanceRechargeLogEditReq 修改操作请求参数
type StoreFinanceRechargeLogEditReq struct {
	Id             uint64      `p:"id" v:"required#主键ID不能为空" dc:"ID"`
	Uid            uint64      `p:"uid"  dc:"ucenterID"`
	RechargeNo     string      `p:"rechargeNo"  dc:"充值单号"`
	RechargeAmount float64     `p:"rechargeAmount"  dc:"充值金额"`
	GiftAmount     float64     `p:"giftAmount"  dc:"赠送金额"`
	PayType        string      `p:"payType"  dc:"支付方式"`
	PayNo          string      `p:"payNo"  dc:"支付单号"`
	Paid           int         `p:"paid"  dc:"是否支付"`
	PayTime        *gtime.Time `p:"payTime"  dc:"支付日期"`
	Remark         string      `p:"remark"  dc:"备注"`
	Status         int         `p:"status"  dc:"状态"`
}

// 订单支付参数
type StoreFinanceRechargePayArgs struct {
	Uid           uint64
	RechargeNo    string
	PayType       string
	Openid        string
	WechatPayType int `p:"wechatPayType" dc:"0=H5支付，1=小程序支付"`
}
