/**
 * @Company: 云南奇讯科技有限公司
 * @Author: yxf
 * @Description: 微信支付相关接口
 * @Date: 2024/8/16 上午9:40
 */

package controller

import (
	"context"
	"github.com/gogf/gf/v2/frame/g"
	"github.com/gogf/gf/v2/net/ghttp"
	"github.com/tiger1103/gfast/v3/api/v1/store/wechat"
	"github.com/tiger1103/gfast/v3/internal/app/store/wechat/service"
)

var WechatPay = new(wechatPayController)

type wechatPayController struct{}

// Notify 处理微信支付通知
func (c *wechatPayController) Notify(ctx context.Context, req *wechat.WechatPayNotifyReq) (res *wechat.WechatPayNotifyRes, err error) {
	g.Log().Debug(ctx, g.RequestFromCtx(ctx))
	res = &wechat.WechatPayNotifyRes{}
	err = service.WechatPay().Notify(ctx, ghttp.RequestFromCtx(ctx).Request)
	if err != nil {
		res.Code = "FAIL"
		res.Message = err.Error()
	}
	return
}

// QueryOrder 支付订单查询
func (c *wechatPayController) QueryOrder(ctx context.Context, req *wechat.WechatPayQuerOrderReq) (res *wechat.WechatPayQuerOrderRes, err error) {
	res = new(wechat.WechatPayQuerOrderRes)
	res, err = service.WechatPay().QueryOrder(ctx, req.OutTradeNo)
	return
}
