/**
 * @Company: 云南奇讯科技有限公司
 * @Author: yxf
 * @Description: 微信支付
 * @Date: 2024/8/13 上午10:57
 */

package model

type WechatPayPayParams struct {
	Amount      int    `json:"amount" dc:"金额单位为分"` // 1元=100分
	OutTradeNo  string `json:"out_trade_no"`
	Attach      string `json:"attach"` // 自定义数据，用来携带支付类型或其他信息
	OpenId      string `json:"openid"`
	Description string `json:"description"`
	NotifyUrl   string `json:"notifyUrl"` // 支付结果通知地址
}

type WechatPayConfig struct {
	AppId               string `json:"appid"`
	WxAppid             string `json:"wxAppid"`
	CertSerial          string `json:"certSerial"`
	ApiV3Key            string `json:"apiV3Key"`
	Mchid               string `json:"mchid"`
	Cert                string `json:"cert"`
	CertKey             string `json:"certKey"`
	MinProgramMchidType string `json:"minProgramMchidType"`
	MinProgramMchid     string `json:"minProgramMchid"`
	WxpayType           string `json:"wxpayType"`
	SubMchid            string `json:"subMchid"`
}

type WechatPayPrepayConfig struct {
	AppId     string `json:"appId"`
	NonceStr  string `json:"nonceStr"`
	Sign      string `json:"sign"`
	TimeStamp string `json:"timeStamp"`
	Package   string `json:"package"`
	PaySign   string `json:"paySign"`
	SignType  string `json:"signType"`
}

type WechatPayQueryByOutTradeNumber struct {
	AmountTotal   int    `json:"amountTotal"`
	Openid        string `json:"openid"`
	successTime   string `json:"successTime"`
	TradeState    string `json:"tradeState"`
	TradeType     string `json:"tradeType"`
	TransactionId string `json:"transactionId"`
}
