// ==========================================================================
// GFast自动生成logic操作代码。
// 生成日期：2023-03-09 16:48:47
// 生成路径: internal/app/ucenter/logic/ucenter_level.go
// 生成人：yxf
// desc:用户等级
// company:云南奇讯科技有限公司
// ==========================================================================

package ucenterFollows

import (
	"context"
	"errors"
	"github.com/gogf/gf/v2/frame/g"
	"github.com/tiger1103/gfast/v3/api/v1/ucenter"
	"github.com/tiger1103/gfast/v3/internal/app/system/consts"
	"github.com/tiger1103/gfast/v3/internal/app/ucenter/dao"
	"github.com/tiger1103/gfast/v3/internal/app/ucenter/model"
	"github.com/tiger1103/gfast/v3/internal/app/ucenter/service"
	"github.com/tiger1103/gfast/v3/library/liberr"
)

func init() {
	service.RegisterUCenterFollows(New())
}

func New() *sUCenterFollows {
	return &sUCenterFollows{}
}

type sUCenterFollows struct{}

func (s *sUCenterFollows) List(ctx context.Context, memberId uint64, req *ucenter.UCenterFollowsListReq) (total, page int, listRes []*model.UCenterFollowsListRes, err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		m := dao.UCenterFollows.Ctx(ctx).WithAll()
		m = m.Where("member_id=?", memberId)
		total, err = m.Count()
		liberr.ErrIsNil(ctx, err, "获取总行数失败")
		if req.PageNum == 0 {
			req.PageNum = 1
		}
		page = req.PageNum
		if req.PageSize == 0 {
			req.PageSize = consts.PageSize
		}
		order := "created_at desc"
		if req.OrderBy != "" {
			order = req.OrderBy
		}
		err = m.WithAll().Page(req.PageNum, req.PageSize).Order(order).Scan(&listRes)
		liberr.ErrIsNil(ctx, err, "获取数据失败")
	})
	return
}

func (s *sUCenterFollows) Add(ctx context.Context, memberId, followerId uint64) (err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		count, _ := dao.UCenterFollows.Ctx(ctx).Where("member_id=? and follower_id=?", memberId, followerId).Count()
		if count > 0 {
			liberr.ErrIsNil(ctx, errors.New("已经关注过该用户"), "已经关注过该用户")
		}
		_, err = dao.UCenterFollows.Ctx(ctx).Insert(g.Map{
			"member_id":   memberId,
			"follower_id": followerId,
		})
		liberr.ErrIsNil(ctx, err, "添加失败")
	})
	return
}

func (s *sUCenterFollows) Delete(ctx context.Context, memberId, followerId uint64) (err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		_, err = dao.UCenterFollows.Ctx(ctx).Where(g.Map{
			"member_id":   memberId,
			"follower_id": followerId,
		}).Delete()
		liberr.ErrIsNil(ctx, err, "删除失败")
	})
	return
}
