// ==========================================================================
// GFast自动生成logic操作代码。
// 生成日期：2023-03-09 16:49:02
// 生成路径: internal/app/ucenter/logic/ucenter_members.go
// 生成人：yxf
// desc:用户中心
// company:云南奇讯科技有限公司
// ==========================================================================

package logic

import (
	"context"
	"errors"
	"fmt"
	"github.com/gogf/gf/v2/crypto/gmd5"
	"github.com/gogf/gf/v2/errors/gerror"
	"github.com/gogf/gf/v2/frame/g"
	"github.com/gogf/gf/v2/os/gtime"
	"github.com/gogf/gf/v2/text/gstr"
	"github.com/gogf/gf/v2/util/gconv"
	"github.com/gogf/gf/v2/util/grand"
	"github.com/gogf/gf/v2/util/guid"
	"github.com/tiger1103/gfast/v3/api/v1/ucenter"
	apiAdmin "github.com/tiger1103/gfast/v3/api/v1/ucenter/admin"
	commonService "github.com/tiger1103/gfast/v3/internal/app/common/service"
	"github.com/tiger1103/gfast/v3/internal/app/system/consts"
	"github.com/tiger1103/gfast/v3/internal/app/ucenter/dao"
	"github.com/tiger1103/gfast/v3/internal/app/ucenter/model"
	"github.com/tiger1103/gfast/v3/internal/app/ucenter/model/do"
	"github.com/tiger1103/gfast/v3/internal/app/ucenter/service"
	"github.com/tiger1103/gfast/v3/library/libUtils"
	"github.com/tiger1103/gfast/v3/library/liberr"
	"math/rand"
	"time"
)

func init() {
	service.RegisterUCenterMembers(New())
}

func New() *sUCenterMembers {
	return &sUCenterMembers{}
}

type sUCenterMembers struct{}

func (s *sUCenterMembers) List(ctx context.Context, req *apiAdmin.UCenterMembersSearchReq) (listRes *apiAdmin.UCenterMembersSearchRes, err error) {
	listRes = new(apiAdmin.UCenterMembersSearchRes)
	err = g.Try(ctx, func(ctx context.Context) {
		m := dao.UCenterMembers.Ctx(ctx).WithAll()
		if req.Nickname != "" {
			m = m.Where(dao.UCenterMembers.Columns().Nickname+" like ?", "%"+req.Nickname+"%")
		}
		if req.Mobile != "" {
			m = m.Where(dao.UCenterMembers.Columns().Mobile+" = ?", req.Mobile)
		}
		if req.Username != "" {
			m = m.Where(dao.UCenterMembers.Columns().Username+" like ?", "%"+req.Username+"%")
		}
		if req.RegType != "" {
			m = m.Where(dao.UCenterMembers.Columns().RegType+" = ?", req.RegType)
		}
		listRes.Total, err = m.Count()
		liberr.ErrIsNil(ctx, err, "获取总行数失败")
		if req.PageNum == 0 {
			req.PageNum = 1
		}
		listRes.CurrentPage = req.PageNum
		if req.PageSize == 0 {
			req.PageSize = consts.PageSize
		}
		order := "id desc"
		if req.OrderBy != "" {
			order = req.OrderBy
		}
		var res []*model.UCenterMembersInfoRes
		err = m.Fields(apiAdmin.UCenterMembersSearchRes{}).Page(req.PageNum, req.PageSize).Order(order).Scan(&res)
		liberr.ErrIsNil(ctx, err, "获取数据失败")
		listRes.List = make([]*model.UCenterMembersListRes, len(res))
		for k, v := range res {
			listRes.List[k] = &model.UCenterMembersListRes{
				Id:          v.Id,
				Username:    v.Username,
				Nickname:    v.Nickname,
				Sex:         v.Sex,
				Mobile:      v.Mobile,
				Uuid:        v.Uuid,
				RegType:     v.RegType,
				Avatar:      v.Avatar,
				CreatedAt:   v.CreatedAt,
				WxOpenid:    v.WxOpenid,
				IsOpen:      v.IsOpen,
				LastLoginIp: v.LastLoginIp,
				LastLoginAt: v.LastLoginAt,
				Qq:          v.Qq,
				Score:       v.Score,
				Level:       v.Level,
				LinkedLevel: v.LinkedLevel,
			}
		}
	})
	return
}

func (s *sUCenterMembers) GetById(ctx context.Context, id uint64) (res *model.UCenterMembersInfoRes, err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		err = dao.UCenterMembers.Ctx(ctx).WithAll().Where(dao.UCenterMembers.Columns().Id, id).Scan(&res)
		liberr.ErrIsNil(ctx, err, "获取信息失败")
	})
	return
}

func (s *sUCenterMembers) userNameOrMobileExists(ctx context.Context, userName, mobile string, id ...uint64) error {
	var user *model.UCenterMembersInfoRes
	err := g.Try(ctx, func(ctx context.Context) {
		m := dao.UCenterMembers.Ctx(ctx)
		if len(id) > 0 {
			m = m.Where(dao.UCenterMembers.Columns().Id+" != ", id)
		}
		m = m.Where(fmt.Sprintf("%s='%s' OR %s='%s'",
			dao.UCenterMembers.Columns().Username,
			userName,
			dao.UCenterMembers.Columns().Mobile,
			mobile))
		err := m.Limit(1).Scan(&user)
		liberr.ErrIsNil(ctx, err, "获取用户信息失败")
		if user == nil {
			return
		}
		if user.Username == userName {
			liberr.ErrIsNil(ctx, gerror.New("用户名已存在"))
		}
		if user.Mobile == mobile {
			liberr.ErrIsNil(ctx, gerror.New("手机号已存在"))
		}
	})
	return err
}

func (s *sUCenterMembers) Add(ctx context.Context, req *apiAdmin.UCenterMembersAddReq) (err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		err = s.userNameOrMobileExists(ctx, req.Username, req.Mobile)
		liberr.ErrIsNil(ctx, err)
		_, err = dao.UCenterMembers.Ctx(ctx).Insert(do.UCenterMembers{
			Username: req.Username,
			Nickname: req.Nickname,
			Sex:      req.Sex,
			Email:    req.Email,
			Mobile:   req.Mobile,
			IsOpen:   req.IsOpen,
			IsSecret: req.IsSecret,
			Qq:       req.Qq,
			Level:    req.Level,
			WxOpenid: req.WxOpenid,
			Uuid:     guid.S(),
		})
		liberr.ErrIsNil(ctx, err, "添加失败")
	})
	return
}

func (s *sUCenterMembers) Edit(ctx context.Context, req *apiAdmin.UCenterMembersEditReq) (err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		err = s.userNameOrMobileExists(ctx, req.Username, req.Mobile, req.Id)
		liberr.ErrIsNil(ctx, err)
		_, err = dao.UCenterMembers.Ctx(ctx).WherePri(req.Id).Update(do.UCenterMembers{
			Username: req.Username,
			Nickname: req.Nickname,
			Sex:      req.Sex,
			Email:    req.Email,
			Mobile:   req.Mobile,
			IsOpen:   req.IsOpen,
			IsSecret: req.IsSecret,
			Qq:       req.Qq,
			Level:    req.Level,
		})
		liberr.ErrIsNil(ctx, err, "修改失败")
	})
	return
}

func (s *sUCenterMembers) ResetPwd(ctx context.Context, req *apiAdmin.UCenterMembersResetPwdReq) (err error) {
	salt := grand.S(10)
	req.NewPassword = libUtils.EncryptPassword(req.NewPassword, salt)
	_, err = dao.UCenterMembers.Ctx(ctx).Where(dao.UCenterMembers.Columns().Id, req.Id).Update(g.Map{
		"password": req.NewPassword,
		"salt":     salt,
	})
	return
}

func (s *sUCenterMembers) Delete(ctx context.Context, ids []uint64) (err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		_, err = dao.UCenterMembers.Ctx(ctx).Delete(dao.UCenterMembers.Columns().Id+" in (?)", ids)
		liberr.ErrIsNil(ctx, err, "删除失败")
	})
	return
}

func (s *sUCenterMembers) GetByIdWithAll(ctx context.Context, id uint64) (res *do.UCenterMembers, err error) {
	err = dao.UCenterMembers.Ctx(ctx).WithAll().Where(dao.UCenterMembers.Columns().Id, id).Scan(&res)
	return
}

func (s *sUCenterMembers) ChangePwd(ctx context.Context, id uint64, newPwd string) (err error) {
	dao.UCenterMembers.Ctx(ctx).WherePri(id).Update(g.Map{
		"password": newPwd,
	})
	return
}

func (s *sUCenterMembers) GetAdminUserByUsernamePassword(ctx context.Context, req *ucenter.UCenterLoginReq) (doMember *do.UCenterMembers, err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		doMember, err = s.GetUserByUsername(ctx, req.Username)
		liberr.ErrIsNil(ctx, err)
		liberr.ValueIsNil(doMember, "账号不存在")
		//验证密码
		if libUtils.EncryptPassword(req.Password, gconv.String(doMember.Salt)) != gconv.String(doMember.Password) {
			liberr.ErrIsNil(ctx, gerror.New("密码错误"))
		}
		//账号状态
		if doMember.IsOpen == 0 {
			liberr.ErrIsNil(ctx, gerror.New("账号未激活"))
		}
	})
	return
}

// GetUserByUsername 通过用户名获取用户信息
func (s *sUCenterMembers) GetUserByUsername(ctx context.Context, username string) (member *do.UCenterMembers, err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		member = &do.UCenterMembers{}
		err = dao.UCenterMembers.Ctx(ctx).Fields(member).Where(dao.UCenterMembers.Columns().Username, username).Scan(member)
		liberr.ErrIsNil(ctx, err, "账号不存在")
	})
	return
}

// GetUserByMobile 通过手机号获取用户信息
func (s *sUCenterMembers) GetUserByMobile(ctx context.Context, mobile string) (member *do.UCenterMembers, err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		member = &do.UCenterMembers{}
		err = dao.UCenterMembers.Ctx(ctx).Fields(member).Where(dao.UCenterMembers.Columns().Mobile, mobile).Scan(member)
		liberr.ErrIsNil(ctx, err, "账号不存在")
	})
	return
}

// GetUserByOpenID 通过wxOpenid获取用户信息
func (s *sUCenterMembers) GetUserByOpenID(ctx context.Context, openId string) (member *do.UCenterMembers, err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		member = &do.UCenterMembers{}
		err = dao.UCenterMembers.Ctx(ctx).Fields(member).Where(dao.UCenterMembers.Columns().WxOpenid+" = ?", openId).Scan(member)
		liberr.ErrIsNil(ctx, err, "用户信息不存在,请先注册账号绑定微信")
	})
	return
}

func (s *sUCenterMembers) UpdateLoginInfo(ctx context.Context, Id uint64, ip string, openId ...string) (err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		data := g.Map{
			dao.UCenterMembers.Columns().LastLoginIp: ip,
			dao.UCenterMembers.Columns().LastLoginAt: gtime.Now(),
		}
		if len(openId) > 0 && openId[0] != "" {
			data[dao.UCenterMembers.Columns().WxOpenid] = openId[0]
		}
		_, err = dao.UCenterMembers.Ctx(ctx).WherePri(Id).Unscoped().Update(data)
		liberr.ErrIsNil(ctx, err, "更新用户登录信息失败")
	})
	return
}

// Register 前台用户注册
func (s *sUCenterMembers) Register(ctx context.Context, req *ucenter.UCenterRegisterReq) (uid int64, err error) {
	salt := grand.S(10)
	password := libUtils.EncryptPassword(req.Password, salt)
	uuid := guid.S()
	nicks := []string{"无名剑士", "飞翔的虎", "幽灵骑士", "闪电骑士", "逆天行者",
		"斗地主低保户", "寒冰战神", "萌面大虾", "草莓棉花糖", "小熊饼干", "奋斗青年",
		"星际穿越者", "时空旅行者", "星际领航员", "会飞的", "爱吃鱼的", "寒冰战神"}
	names := []string{"米奇", "唐老鸭", "高飞", "花木兰", "大雄",
		"哆啦 A 梦", "胖虎", "章鱼哥", "光头强", "阿童木",
		"黑猫警长", "卡卡西", "加菲猫", "咖啡猫", "乔治", "月光宝盒", "喜羊羊", "懒洋洋", "灰太狼", "沸羊羊", "赵子龙"}
	// 检查推广人
	nickname := nicks[rand.Intn(len(nicks))] + names[rand.Intn(len(names))] + gconv.String(grand.N(100, 9999))
	referrer, err := dao.UCenterMembers.Ctx(ctx).Where("id", req.Referrer).One()
	if referrer == nil {
		req.Referrer = "0"
	}
	data := g.Map{
		"username": req.Username,
		"mobile":   req.Mobile,
		"nickname": nickname,
		"salt":     salt,
		"password": password,
		"uuid":     uuid,
		"level":    1,
		"reg_type": "username",
		"referrer": req.Referrer,
	}
	//if req.Mobile != "" {
	//	data["nickname"] = gstr.SubStr(req.Mobile, 7)
	//}
	if req.Mobile != "" {
		data["reg_type"] = "mobile"
	}
	uid, err = dao.UCenterMembers.Ctx(ctx).InsertAndGetId(data)
	return
}

// IsExist 检查用户是否存在
func (s *sUCenterMembers) IsMemberExist(ctx context.Context, req *ucenter.UCenterIsMemberExistReq) (res bool) {
	m := dao.UCenterMembers.Ctx(ctx)
	if req.Mobile != "" {
		m = m.Where(dao.UCenterMembers.Columns().Mobile+"=?", req.Mobile)
	}
	if req.Username != "" {
		m = m.Where(dao.UCenterMembers.Columns().Username+"=?", req.Username)
	}
	count, _ := m.Count()
	if count > 0 {
		return true
	}
	return
}

// MemberDataMasking 用户数据脱敏
func (s *sUCenterMembers) MemberDataMasking(memberInfo *model.UCenterMembersInfoRes) *model.UCenterMembersInfoRes {
	if memberInfo.Mobile != "" {
		memberInfo.Mobile = gstr.HideStr(memberInfo.Mobile, 40, "*")
	}
	if memberInfo.WxOpenid != "" {
		memberInfo.WxOpenid = gstr.HideStr(memberInfo.WxOpenid, 40, "*")
	}
	if memberInfo.Qq != "" {
		memberInfo.Qq = gstr.HideStr(memberInfo.Qq, 40, "*")
	}
	if memberInfo.Email != "" {
		memberInfo.Email = gstr.HideStr(memberInfo.Email, 40, "*")
	}
	return memberInfo
}

// EditAvatar 修改用户头像
func (s *sUCenterMembers) EditAvatar(ctx context.Context, memberId uint64, filePath string) (err error) {
	_, err = dao.UCenterMembers.Ctx(ctx).WherePri(memberId).Update(g.Map{"avatar": filePath})
	return
}

// EditCover 修改用户封面
func (s *sUCenterMembers) EditCover(ctx context.Context, memberId uint64, filePath string) (err error) {
	_, err = dao.UCenterMembers.Ctx(ctx).WherePri(memberId).Update(g.Map{"cover": filePath})
	return
}

// EditProfile 修改用户信息
func (s *sUCenterMembers) EditProfile(ctx context.Context, memberId uint64, req *model.UCenterMembersEditReq) (err error) {
	_, err = dao.UCenterMembers.Ctx(ctx).WherePri(memberId).Update(g.Map{
		"nickname":    req.Nickname,
		"sex":         req.Sex,
		"email":       req.Email,
		"avatar":      req.Avatar,
		"qq":          req.Qq,
		"birthday":    req.Birthday,
		"description": req.Description,
	})
	return
}

// BindWechat 绑定用户手机号
func (s *sUCenterMembers) BindMobile(ctx context.Context, memberId uint64, mobile string) (err error) {
	count, err := dao.UCenterMembers.Ctx(ctx).Where("mobile=?", gstr.Trim(mobile)).Count()
	if err != nil {
		return err
	}
	if count > 0 {
		return errors.New("该手机号已绑定！")
	}
	_, err = dao.UCenterMembers.Ctx(ctx).WherePri(memberId).Update(g.Map{
		"mobile": mobile,
	})
	return
}

// UnbindMobile 解绑用户手机
func (s *sUCenterMembers) UnbindMobile(ctx context.Context, memberId uint64) (err error) {
	_, err = dao.UCenterMembers.Ctx(ctx).WherePri(memberId).Update(g.Map{
		"mobile": "",
	})
	return
}

// BindEmail 绑定用户email
func (s *sUCenterMembers) BindEmail(ctx context.Context, memberId uint64, email string) (err error) {
	_, err = dao.UCenterMembers.Ctx(ctx).WherePri(memberId).Update(g.Map{
		"email": email,
	})
	return
}

// UnbindEmail 解绑用户邮箱
func (s *sUCenterMembers) UnbindEmail(ctx context.Context, memberId uint64) (err error) {
	_, err = dao.UCenterMembers.Ctx(ctx).WherePri(memberId).Update(g.Map{
		"email": "",
	})
	return
}

// BindMobile 用户绑定微信
func (s *sUCenterMembers) BindWechat(ctx context.Context, memberId uint64, wxOpenid string) (err error) {
	count, err := dao.UCenterMembers.Ctx(ctx).Where("wx_openid=?", gstr.Trim(wxOpenid)).Count()
	if err != nil {
		return err
	}
	if count > 0 {
		return errors.New("已有账号绑定该微信！")
	}
	_, err = dao.UCenterMembers.Ctx(ctx).WherePri(memberId).Update(g.Map{
		"wx_openid": wxOpenid,
	})
	return
}

// UnbindWechat 解绑用户微信
func (s *sUCenterMembers) UnbindWechat(ctx context.Context, memberId uint64) (err error) {
	_, err = dao.UCenterMembers.Ctx(ctx).WherePri(memberId).Update(g.Map{
		"wx_openid": "",
	})
	return
}

func (s *sUCenterMembers) Forgot(ctx context.Context, req *ucenter.UCenterForgotReq) (forgotKey string, err error) {
	var memberInfo *model.UCenterMembersInfoRes
	err = dao.UCenterMembers.Ctx(ctx).Where("username", gstr.Trim(req.Username)).Scan(&memberInfo)
	if err != nil {
		return
	}
	if memberInfo == nil {
		return "", errors.New("根据账户名" + req.Username + "未找到用户信息")
	}
	if req.RegType == "mobile" {
		if memberInfo.Mobile != req.Mobile {
			return "", errors.New("手机号和用户名不匹配")
		}
		// todo 这里需要实现发送短信验证码
	} else {
		if memberInfo.Email != req.Email {
			return "", errors.New("邮箱号和用户名不匹配")
		}
		mailCode := commonService.Cache().Get(ctx, req.Email+"_verify_code")
		if mailCode.String() != req.VerifyCode {
			return "", errors.New("邮箱验证码错误")
		}
	}
	forgotKey = gmd5.MustEncryptString("forgot_key_" + req.Username + gtime.TimestampMicroStr())
	commonService.Cache().Set(ctx, forgotKey, req.Username, time.Hour*24)
	return
}

// 忘记密码重设
func (s *sUCenterMembers) ForgotResetPwd(ctx context.Context, req *ucenter.UCenterResetPwdReq) (err error) {
	hasKey := commonService.Cache().Contains(ctx, req.ForgotKey)
	if !hasKey {
		return errors.New("无效的操作")
	}
	username := commonService.Cache().Get(ctx, req.ForgotKey).String()
	if username == "" {
		return errors.New("无效的操作")
	}
	if req.Password != req.Password2 {
		return errors.New("两次输入的密码不一致")
	}
	salt := grand.S(10)
	password := libUtils.EncryptPassword(req.Password, salt)
	_, err = dao.UCenterMembers.Ctx(ctx).Where("username=?", gstr.Trim(username)).Update(g.Map{
		"password": password,
		"salt":     salt,
	})
	return
}

// CodeResetPwd 验证码 修改密码
func (s *sUCenterMembers) CodeResetPwd(ctx context.Context, req *ucenter.UcenterCodeResetPwdReq) (err error) {
	isExist := s.IsMemberExist(ctx, &ucenter.UCenterIsMemberExistReq{
		Mobile: req.Mobile,
	})
	if !isExist {
		return errors.New("用户不存在")
	}
	// todo检查手机验证码
	salt := grand.S(10)
	password := libUtils.EncryptPassword(req.Password, salt)
	_, err = dao.UCenterMembers.Ctx(ctx).Where("mobile=?", gstr.Trim(req.Mobile)).Update(g.Map{
		"password": password,
		"salt":     salt,
	})

	return
}
