// ==========================================================================
// GFast自动生成logic操作代码。
// 生成日期：2023-03-09 16:51:57
// 生成路径: internal/app/ucenter/logic/ucenter_message.go
// 生成人：yxf
// desc:用户消息
// company:云南奇讯科技有限公司
// ==========================================================================

package logic

import (
	"context"
	"github.com/gogf/gf/v2/frame/g"
	apiAdmin "github.com/tiger1103/gfast/v3/api/v1/ucenter/admin"

	"github.com/tiger1103/gfast/v3/internal/app/system/consts"
	"github.com/tiger1103/gfast/v3/internal/app/ucenter/dao"
	"github.com/tiger1103/gfast/v3/internal/app/ucenter/model"
	"github.com/tiger1103/gfast/v3/internal/app/ucenter/model/do"
	"github.com/tiger1103/gfast/v3/internal/app/ucenter/service"
	"github.com/tiger1103/gfast/v3/library/liberr"
)

func init() {
	service.RegisterUCenterMessage(New())
}

func New() *sUCenterMessage {
	return &sUCenterMessage{}
}

type sUCenterMessage struct{}

func (s *sUCenterMessage) List(ctx context.Context, req *apiAdmin.UCenterMessageSearchReq, memberId uint64) (listRes *apiAdmin.UCenterMessageSearchRes, err error) {
	listRes = new(apiAdmin.UCenterMessageSearchRes)
	err = g.Try(ctx, func(ctx context.Context) {
		m := dao.UCenterMessage.Ctx(ctx).WithAll()
		if memberId > 0 {
			if req.MsgType != "recv" {
				m = m.Where(dao.UCenterMessage.Columns().Sender, memberId)
			} else {
				m = m.Where(dao.UCenterMessage.Columns().Receiver, memberId)
			}
		}

		listRes.Total, err = m.Count()
		liberr.ErrIsNil(ctx, err, "获取总行数失败")
		if req.PageNum == 0 {
			req.PageNum = 1
		}
		listRes.CurrentPage = req.PageNum
		if req.PageSize == 0 {
			req.PageSize = consts.PageSize
		}
		order := "id desc"
		if req.OrderBy != "" {
			order = req.OrderBy
		}
		err = m.WithAll().Page(req.PageNum, req.PageSize).Order(order).Scan(&listRes.List)
		liberr.ErrIsNil(ctx, err, "获取数据失败")
	})
	return
}

func (s *sUCenterMessage) GetById(ctx context.Context, id uint64, memberId uint64) (res *model.UCenterMessageInfoRes, err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		m := dao.UCenterMessage.Ctx(ctx)
		if memberId > 0 {
			m = m.Where("(sender=? or receiver=?", memberId, memberId)
		}
		err = m.WithAll().Where(dao.UCenterMessage.Columns().Id, id).Scan(&res)
		liberr.ErrIsNil(ctx, err, "获取信息失败")
	})
	return
}

func (s *sUCenterMessage) Add(ctx context.Context, req *apiAdmin.UCenterMessageAddReq) (err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		_, err = dao.UCenterMessage.Ctx(ctx).Insert(do.UCenterMessage{
			Sender:   req.Sender,
			Receiver: req.Receiver,
			Content:  req.Content,
			Status:   req.Status,
			Pid:      req.Pid,
		})
		liberr.ErrIsNil(ctx, err, "添加失败")
	})
	return
}

func (s *sUCenterMessage) Edit(ctx context.Context, req *apiAdmin.UCenterMessageEditReq) (err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		_, err = dao.UCenterMessage.Ctx(ctx).WherePri(req.Id).Update(do.UCenterMessage{
			Sender:   req.Sender,
			Receiver: req.Receiver,
			Content:  req.Content,
			Status:   req.Status,
			Pid:      req.Pid,
		})
		liberr.ErrIsNil(ctx, err, "修改失败")
	})
	return
}

func (s *sUCenterMessage) Delete(ctx context.Context, ids []uint64, memberId uint64) (err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		m := dao.UCenterMessage.Ctx(ctx)
		if memberId > 0 {
			m.Where("(sender=? or receiver=?", memberId, memberId)
		}
		_, err = m.Delete(dao.UCenterMessage.Columns().Id+" in (?)", ids)
		liberr.ErrIsNil(ctx, err, "删除失败")
	})
	return
}
