// ==========================================================================
// GFast自动生成logic操作代码。
// 生成日期：2023-03-09 16:56:57
// 生成路径: internal/app/ucenter/logic/ucenter_notifications.go
// 生成人：yxf
// desc:用户通知
// company:云南奇讯科技有限公司
// ==========================================================================

package logic

import (
	"context"
	"github.com/gogf/gf/v2/frame/g"
	"github.com/gogf/gf/v2/os/glog"
	apiAdmin "github.com/tiger1103/gfast/v3/api/v1/ucenter/admin"
	commonService "github.com/tiger1103/gfast/v3/internal/app/common/service"
	systemConsts "github.com/tiger1103/gfast/v3/internal/app/system/consts"
	ucenterConsts "github.com/tiger1103/gfast/v3/internal/app/ucenter/consts"
	"github.com/tiger1103/gfast/v3/internal/app/ucenter/dao"
	"github.com/tiger1103/gfast/v3/internal/app/ucenter/model"
	"github.com/tiger1103/gfast/v3/internal/app/ucenter/model/do"
	"github.com/tiger1103/gfast/v3/internal/app/ucenter/service"
	"github.com/tiger1103/gfast/v3/library/liberr"
)

func init() {
	service.RegisterUCenterNotifications(New())
	commonService.EventBus().Subscribe(ucenterConsts.UCENTER_NOTIFICATION_ADD, func(data *apiAdmin.UCenterNotificationsAddReq) {
		err := service.UCenterNotifications().Add(context.TODO(), data)
		if err != nil {
			glog.Error(context.TODO(), err)
		}
	})
}

func New() *sUCenterNotifications {
	return &sUCenterNotifications{}
}

type sUCenterNotifications struct{}

func (s *sUCenterNotifications) List(ctx context.Context, req *apiAdmin.UCenterNotificationsSearchReq, memberId uint64) (listRes *apiAdmin.UCenterNotificationsSearchRes, err error) {
	listRes = new(apiAdmin.UCenterNotificationsSearchRes)
	err = g.Try(ctx, func(ctx context.Context) {
		m := dao.UCenterNotifications.Ctx(ctx)
		if memberId > 0 {
			m.Where("member_id=?", memberId)
		}
		listRes.Total, err = m.Count()
		liberr.ErrIsNil(ctx, err, "获取总行数失败")
		if req.PageNum == 0 {
			req.PageNum = 1
		}
		listRes.CurrentPage = req.PageNum
		if req.PageSize == 0 {
			req.PageSize = systemConsts.PageSize
		}
		order := "id desc"
		if req.OrderBy != "" {
			order = req.OrderBy
		}
		err = m.WithAll().Fields(apiAdmin.UCenterNotificationsSearchRes{}).Page(req.PageNum, req.PageSize).Order(order).Scan(&listRes.List)
		liberr.ErrIsNil(ctx, err, "获取数据失败")
	})
	return
}

func (s *sUCenterNotifications) GetById(ctx context.Context, id uint64, memberId uint64) (res *model.UCenterNotificationsInfoRes, err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		m := dao.UCenterNotifications.Ctx(ctx)
		if memberId > 0 {
			m.Where("member_id=?", memberId)
		}
		err = m.WithAll().Where(dao.UCenterNotifications.Columns().Id, id).Scan(&res)
		liberr.ErrIsNil(ctx, err, "获取信息失败")
	})
	return
}

func (s *sUCenterNotifications) ChangeStatus(ctx context.Context, id uint64, memberId uint64) (err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		_, err = dao.UCenterNotifications.Ctx(ctx).Where(g.Map{
			dao.UCenterNotifications.Columns().Id:       id,
			dao.UCenterNotifications.Columns().MemberId: memberId,
		}).Update(g.Map{"status": 1})
		liberr.ErrIsNil(ctx, err, "获取信息失败")
	})
	return
}

func (s *sUCenterNotifications) Add(ctx context.Context, req *apiAdmin.UCenterNotificationsAddReq) (err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		_, err = dao.UCenterNotifications.Ctx(ctx).Insert(do.UCenterNotifications{
			Title:    req.Title,
			Type:     req.Type,
			Content:  req.Content,
			Status:   req.Status,
			MemberId: req.MemberId,
		})
		liberr.ErrIsNil(ctx, err, "添加失败")
	})
	return
}

func (s *sUCenterNotifications) Edit(ctx context.Context, req *apiAdmin.UCenterNotificationsEditReq) (err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		_, err = dao.UCenterNotifications.Ctx(ctx).WherePri(req.Id).Update(do.UCenterNotifications{
			Title:    req.Title,
			Type:     req.Type,
			Content:  req.Content,
			Status:   req.Status,
			MemberId: req.MemberId,
		})
		liberr.ErrIsNil(ctx, err, "修改失败")
	})
	return
}

func (s *sUCenterNotifications) Delete(ctx context.Context, ids []uint64, memberId uint64) (err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		m := dao.UCenterNotifications.Ctx(ctx)
		if memberId > 0 {
			m.Where("member_id=?", memberId)
		}
		_, err = m.Delete(dao.UCenterNotifications.Columns().Id+" in (?)", ids)
		liberr.ErrIsNil(ctx, err, "删除失败")
	})
	return
}
