// ==========================================================================
// GFast自动生成service操作代码。
// 生成日期：2023-03-09 16:49:02
// 生成路径: internal/app/ucenter/service/ucenter_members.go
// 生成人：yxf
// desc:用户中心
// company:云南奇讯科技有限公司
// ==========================================================================

package service

import (
	"context"
	"github.com/tiger1103/gfast/v3/api/v1/ucenter"
	apiAdmin "github.com/tiger1103/gfast/v3/api/v1/ucenter/admin"
	"github.com/tiger1103/gfast/v3/internal/app/ucenter/model"
	"github.com/tiger1103/gfast/v3/internal/app/ucenter/model/do"
)

type IUCenterMembers interface {
	List(ctx context.Context, req *apiAdmin.UCenterMembersSearchReq) (res *apiAdmin.UCenterMembersSearchRes, err error)
	GetById(ctx context.Context, Id uint64) (res *model.UCenterMembersInfoRes, err error)
	GetByIdWithAll(ctx context.Context, Id uint64) (res *do.UCenterMembers, err error)
	GetAdminUserByUsernamePassword(ctx context.Context, req *ucenter.UCenterLoginReq) (member *do.UCenterMembers, err error)
	MemberDataMasking(memberInfo *model.UCenterMembersInfoRes) *model.UCenterMembersInfoRes
	GetUserByUsername(ctx context.Context, mobile string) (member *do.UCenterMembers, err error)
	GetUserByMobile(ctx context.Context, username string) (member *do.UCenterMembers, err error)
	GetUserByOpenID(ctx context.Context, openId string) (member *do.UCenterMembers, err error)
	Add(ctx context.Context, req *apiAdmin.UCenterMembersAddReq) (err error)
	// Register 注册
	Register(ctx context.Context, req *ucenter.UCenterRegisterReq) (uid int64, err error)
	// IsMemberExist 判断用户是否存在
	IsMemberExist(ctx context.Context, req *ucenter.UCenterIsMemberExistReq) (res bool)
	Edit(ctx context.Context, req *apiAdmin.UCenterMembersEditReq) (err error)
	// ResetPwd 重置密码
	ResetPwd(ctx context.Context, req *apiAdmin.UCenterMembersResetPwdReq) (err error)
	// ChangePwd 修改密码
	ChangePwd(ctx context.Context, id uint64, newPwd string) (err error)
	// Delete 删除
	Delete(ctx context.Context, Id []uint64) (err error)
	// UpdateLoginInfo 更新登录信息
	UpdateLoginInfo(ctx context.Context, Id uint64, ip string, openId ...string) (err error)
	// EditAvatar 修改个人头像
	EditAvatar(ctx context.Context, memberId uint64, filePath string) (err error)
	// EditCover 修改个人封面
	EditCover(ctx context.Context, memberId uint64, filePath string) (err error)
	// EditProfile 修改个人资料
	EditProfile(ctx context.Context, memberId uint64, req *model.UCenterMembersEditReq) (err error)
	// BindMobile 绑定手机
	BindMobile(ctx context.Context, memberId uint64, mobile string) (err error)

	// UnbindMobile 解绑手机
	UnbindMobile(ctx context.Context, memberId uint64) (err error)
	// BindWechat 用户绑定微信
	BindWechat(ctx context.Context, memberId uint64, wxOpenid string) (err error)
	//UnbindWechat 解绑用户微信
	UnbindWechat(ctx context.Context, memberId uint64) (err error)
	// BindEmail 绑定邮箱
	BindEmail(ctx context.Context, memberId uint64, email string) (err error)
	// UnbindEmail 解绑邮箱
	UnbindEmail(ctx context.Context, memberId uint64) (err error)
	// Forgot 忘记密码
	Forgot(ctx context.Context, req *ucenter.UCenterForgotReq) (forgotKey string, err error)
	// ForgotResetPwd 忘记密码重置密码
	ForgotResetPwd(ctx context.Context, req *ucenter.UCenterResetPwdReq) (err error)
	// CodeResetPwd 手机验证码修改密码
	CodeResetPwd(ctx context.Context, req *ucenter.UcenterCodeResetPwdReq) (err error)
}

var localUCenterMembers IUCenterMembers

func UCenterMembers() IUCenterMembers {
	if localUCenterMembers == nil {
		panic("implement not found for interface IUCenterMembers, forgot register?")
	}
	return localUCenterMembers
}

func RegisterUCenterMembers(i IUCenterMembers) {
	localUCenterMembers = i
}
